-- v1.0r

local challengemode = true  -- Challenge Mode Dungeon
local mythicraid = true     -- 20-player Mythic Raid
local heroicraid = true     -- 10-30-player Heroic Raid
local normalraid = true     -- 10-30-player Normal Raid
local lookforraid = true    -- 10-30-player Raid Finder
local dungeon = false       -- 5-player Dungeon
local heroicdungeon = false -- 5-player Heroic Dungeon
local scenario = false      -- Scenario, Proving Grounds
local legacy = false        -- Legacy Raid
local Announce = true       -- Announce in chat for on and off

-- true = on, false = off

local Debug = false

local function ann(msg)
	if (Announce) then
		ChatFrame1:AddMessage(msg)
	end
end

local function debug(msg)
	if (Debug) then
		ChatFrame1:AddMessage(msg)
	end
end

local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
EventFrame:SetScript("OnEvent", function(self, event, ...)
	local name, type, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance, mapID, instanceGroupSize = GetInstanceInfo()
	if (challengemode) and type == "party" and difficulty == 8 then
	-- 8 - Challenge Mode Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Challenge Mode, /combatlog ON")
		LoggingCombat(true)
	elseif (mythicraid) and type == "raid" and difficulty == 16 then
	-- 16 - 20-player Mythic Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Mythic Raid, /combatlog ON")
		LoggingCombat(true)
	elseif (heroicraid) and type == "raid" and difficulty == 15 then
	-- 15 - 10-30-player Heroic Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Heroic Raid, /combatlog ON")
		LoggingCombat(true)
	elseif (normalraid) and type == "raid" and difficulty == 14 then
	-- 14 - 10-30-player Normal Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Normal Raid, /combatlog ON")
		LoggingCombat(true)
	elseif (lookforraid) and type == "raid" and difficulty == 17 then
	-- 17 - 10-30-player Raid Finder Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Raid Finder, /combatlog ON")
		LoggingCombat(true)
	elseif (dungeon) and type == "party" and difficulty == 1 and maxPlayers == 5 then
	-- 1 - 5-player Instance, filtering Garrison
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-man Dungeon, /combatlog ON")
		LoggingCombat(true)
	elseif (heroicdungeon) and type == "party" and difficulty == 2  and maxPlayers == 5 then
	-- 2 - 5-player Heroic Instance, filtering Garrison
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-man Heroic Dungeon, /combatlog ON")
		LoggingCombat(true)
	elseif (scenario) and type == "scenario" then
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Scenario, /combatlog ON")
		LoggingCombat(true)
	elseif (legacy) and type == "raid" and (difficulty == 3 or difficulty == 4 or difficulty == 5 or difficulty == 6 or difficulty == 7 or difficulty == 9) then
	-- 3 - 10-player Raid Instance, 4 - 25-player Raid Instance, 5 - 10-player Heroic Raid Instance, 6 - 25-player Heroic Raid Instance, 7 - 25-player Raid Finder Instance, 9 - 40-player Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Legacy Raid, /combatlog ON")
		LoggingCombat(true)
	else
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("/combatlog: OFF")
		LoggingCombat(false)
	end
end)